# Class TimestampWitness<P>`Abstract`

#### Type Parameters

- #### P extends WitnessParams = WitnessParams

#### Hierarchy

- AbstractWitness<P>
  - TimestampWitness

- Defined in modules/packages/witness/dist/types/TimestampWitness.d.ts:5

#####
Index

### Constructors

constructor

### Properties

_baseModuleQueryAccountPaths
_queryAccounts
_started
account
commitArchivist
downResolver
eventData
moduleConfigQueryValidator
params
readArchivist
supportedQueryValidator
upResolver
writeArchivist
configSchema
defaultLogger?

### Accessors

_queryAccountPaths
address
allowAnonymous
config
logger
queries
queryAccountPaths
queryAccounts
targetSet

### Methods

bindHashes
bindHashesInternal
bindQuery
bindQueryInternal
bindQueryResult
clearListeners
discover
emit
emitSerial
initializeQueryAccounts
listenerCount
loadAccount
moduleAccountQuery
observe
off
offAny
on
onAny
once
query
queryHandler
queryable
resolve
start
started
stop
subscribe
validateConfig
create
factory

## Constructors

### constructor

- new TimestampWitness<P>(params): TimestampWitness<P>

- #### Type Parameters

  - #### P extends WitnessParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.witness.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    schema: "network.xyo.witness.config";
    targetSet?: SchemaFields & PayloadFields & PayloadSet & {
    schema: "network.xyo.payload.set";
    };
    }, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined> = WitnessParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.witness.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    schema: "network.xyo.witness.config";
    targetSet?: SchemaFields & PayloadFields & PayloadSet & {
    schema: "network.xyo.payload.set";
    };
    }, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>

  #### Parameters

  - ##### params: P

  #### Returns TimestampWitness<P>

  Inherited from AbstractWitness.constructor

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:22

## Properties

### `Protected` `Readonly` _baseModuleQueryAccountPaths

_baseModuleQueryAccountPaths: Record<"network.xyo.query.module.discover" | "network.xyo.query.module.account" | "network.xyo.query.module.subscribe", string>

Inherited from AbstractWitness._baseModuleQueryAccountPaths

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:16

### `Protected` `Readonly` _queryAccounts

_queryAccounts: Record<"network.xyo.query.module.discover" | "network.xyo.query.module.account" | "network.xyo.query.module.subscribe", undefined | AccountInstance>

Inherited from AbstractWitness._queryAccounts

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:17

### `Protected` _started

_started: boolean

Inherited from AbstractWitness._started

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:18

### `Protected` `Readonly` account

account: AccountInstance

Inherited from AbstractWitness.account

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:19

### `Protected` commitArchivist

commitArchivist: (() => Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: string;
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<Omit<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: "network.xyo.archivist.config";
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<{
parents?: ArchivistParents;
schema: "network.xyo.archivist.config";
storeParentReads?: boolean;
} & Omit<undefined, "schema">, "schema">, "schema"> & {
schema: string;
}, "schema">, undefined>, ArchivistModuleEventData>>)

#### Type declaration

- - (): Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.archivist.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    parents?: ArchivistParents;
    schema: "network.xyo.archivist.config";
    storeParentReads?: boolean;
    } & Omit<undefined, "schema">, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ArchivistModuleEventData>>

  - #### Returns Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.archivist.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    parents?: ArchivistParents;
    schema: "network.xyo.archivist.config";
    storeParentReads?: boolean;
    } & Omit<undefined, "schema">, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ArchivistModuleEventData>>

Inherited from AbstractWitness.commitArchivist

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:44

### `Readonly` downResolver

downResolver: CompositeModuleResolver

Inherited from AbstractWitness.downResolver

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:14

### eventData

eventData: WitnessModuleEventData

Inherited from AbstractWitness.eventData

- Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:4

### `Protected` `Readonly` moduleConfigQueryValidator

moduleConfigQueryValidator: Queryable<SchemaFields & PayloadFields & BoundWitnessFields & {
query: string;
resultSet?: string;
schema: "network.xyo.boundwitness";
}>

Inherited from AbstractWitness.moduleConfigQueryValidator

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:20

### `Readonly` params

params: P

Inherited from AbstractWitness.params

- Defined in protocol/packages/core/dist/types/lib/Base.d.ts:20

### `Protected` readArchivist

readArchivist: (() => Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: string;
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<Omit<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: "network.xyo.archivist.config";
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<{
parents?: ArchivistParents;
schema: "network.xyo.archivist.config";
storeParentReads?: boolean;
} & Omit<undefined, "schema">, "schema">, "schema"> & {
schema: string;
}, "schema">, undefined>, ArchivistModuleEventData>>)

#### Type declaration

- - (): Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.archivist.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    parents?: ArchivistParents;
    schema: "network.xyo.archivist.config";
    storeParentReads?: boolean;
    } & Omit<undefined, "schema">, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ArchivistModuleEventData>>

  - #### Returns Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.archivist.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    parents?: ArchivistParents;
    schema: "network.xyo.archivist.config";
    storeParentReads?: boolean;
    } & Omit<undefined, "schema">, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ArchivistModuleEventData>>

Inherited from AbstractWitness.readArchivist

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:80

### `Protected` `Readonly` supportedQueryValidator

supportedQueryValidator: Queryable<SchemaFields & PayloadFields & BoundWitnessFields & {
query: string;
resultSet?: string;
schema: "network.xyo.boundwitness";
}>

Inherited from AbstractWitness.supportedQueryValidator

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:21

### `Readonly` upResolver

upResolver: CompositeModuleResolver

Inherited from AbstractWitness.upResolver

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:15

### `Protected` writeArchivist

writeArchivist: (() => Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: string;
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<Omit<SchemaFields & PayloadFields & {
archivist?: ArchivistModuleConfig;
name?: string;
paging?: Record<string, {
size?: number;
}>;
schema: "network.xyo.archivist.config";
security?: {
allowAnonymous?: boolean;
allowed?: Record<string, (string | CosigningAddressSet)[]>;
disallowed?: Record<string, string[]>;
};
storeQueries?: boolean;
} & Omit<{
parents?: ArchivistParents;
schema: "network.xyo.archivist.config";
storeParentReads?: boolean;
} & Omit<undefined, "schema">, "schema">, "schema"> & {
schema: string;
}, "schema">, undefined>, ArchivistModuleEventData>>)

#### Type declaration

- - (): Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.archivist.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    parents?: ArchivistParents;
    schema: "network.xyo.archivist.config";
    storeParentReads?: boolean;
    } & Omit<undefined, "schema">, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ArchivistModuleEventData>>

  - #### Returns Promise<undefined | ArchivistModule<ArchivistParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.archivist.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<{
    parents?: ArchivistParents;
    schema: "network.xyo.archivist.config";
    storeParentReads?: boolean;
    } & Omit<undefined, "schema">, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ArchivistModuleEventData>>

Inherited from AbstractWitness.writeArchivist

- Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:116

### `Static` configSchema

configSchema: string

Inherited from AbstractWitness.configSchema

- Defined in modules/packages/witness/dist/types/AbstractWitness.d.ts:7

### `Static` `Optional` defaultLogger

defaultLogger?: Logger

Inherited from AbstractWitness.defaultLogger

- Defined in protocol/packages/core/dist/types/lib/Base.d.ts:21

## Accessors

### `Protected` _queryAccountPaths

- get _queryAccountPaths(): Record<"network.xyo.query.witness.observe", string>

- #### Returns Record<"network.xyo.query.witness.observe", string>

  Inherited from AbstractWitness._queryAccountPaths

  - Defined in modules/packages/witness/dist/types/AbstractWitness.d.ts:12

### address

- get address(): string

- #### Returns string

  Inherited from AbstractWitness.address

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:23

### allowAnonymous

- get allowAnonymous(): boolean

- #### Returns boolean

  Inherited from AbstractWitness.allowAnonymous

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:24

### config

- get config(): TParams["config"]

- #### Returns TParams["config"]

  Inherited from AbstractWitness.config

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:25

### `Protected` logger

- get logger(): Logger | Console

- #### Returns Logger | Console

  Inherited from AbstractWitness.logger

  - Defined in protocol/packages/core/dist/types/lib/Base.d.ts:23

### queries

- get queries(): string[]

- #### Returns string[]

  Inherited from AbstractWitness.queries

  - Defined in modules/packages/witness/dist/types/AbstractWitness.d.ts:8

### queryAccountPaths

- get queryAccountPaths(): Readonly<Record<string, undefined | string>>

- #### Returns Readonly<Record<string, undefined | string>>

  Inherited from AbstractWitness.queryAccountPaths

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:27

### queryAccounts

- get queryAccounts(): Readonly<Record<string, undefined | AccountInstance>>

- #### Returns Readonly<Record<string, undefined | AccountInstance>>

  Inherited from AbstractWitness.queryAccounts

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:28

### targetSet

- get targetSet(): undefined | SchemaFields & PayloadFields & PayloadSet & {
  schema: "network.xyo.payload.set";
  }

- #### Returns undefined | SchemaFields & PayloadFields & PayloadSet & {
  schema: "network.xyo.payload.set";
  }

  Inherited from AbstractWitness.targetSet

  - Defined in modules/packages/witness/dist/types/AbstractWitness.d.ts:9

## Methods

### `Protected` bindHashes

- bindHashes(hashes, schema, account?): PromiseEx<unknown, AccountInstance>

- #### Parameters

  - ##### hashes: string[]

  - ##### schema: string[]

  - ##### `Optional` account: AccountInstance

  #### Returns PromiseEx<unknown, AccountInstance>

  Inherited from AbstractWitness.bindHashes

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:39

### `Protected` bindHashesInternal

- bindHashesInternal(hashes, schema, account?): Promise<SchemaFields & PayloadFields & BoundWitnessFields & {
  schema: "network.xyo.boundwitness";
  }>

- #### Parameters

  - ##### hashes: string[]

  - ##### schema: string[]

  - ##### `Optional` account: AccountInstance

  #### Returns Promise<SchemaFields & PayloadFields & BoundWitnessFields & {
  schema: "network.xyo.boundwitness";
  }>

  Inherited from AbstractWitness.bindHashesInternal

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:40

### `Protected` bindQuery

- bindQuery<T>(query, payloads?, account?): PromiseEx<[SchemaFields & PayloadFields & BoundWitnessFields & {
  query: string;
  resultSet?: string;
  schema: "network.xyo.boundwitness";
  }, (SchemaFields & PayloadFields & {
  schema: string;
  })[]], AccountInstance>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    } | PayloadWrapper<SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    }>

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` account: AccountInstance

  #### Returns PromiseEx<[SchemaFields & PayloadFields & BoundWitnessFields & {
  query: string;
  resultSet?: string;
  schema: "network.xyo.boundwitness";
  }, (SchemaFields & PayloadFields & {
  schema: string;
  })[]], AccountInstance>

  Inherited from AbstractWitness.bindQuery

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:41

### `Protected` bindQueryInternal

- bindQueryInternal<T>(query, payloads?, account?): Promise<[SchemaFields & PayloadFields & BoundWitnessFields & {
  query: string;
  resultSet?: string;
  schema: "network.xyo.boundwitness";
  }, (SchemaFields & PayloadFields & {
  schema: string;
  })[]]>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    } | PayloadWrapper<SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    }>

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` account: AccountInstance

  #### Returns Promise<[SchemaFields & PayloadFields & BoundWitnessFields & {
  query: string;
  resultSet?: string;
  schema: "network.xyo.boundwitness";
  }, (SchemaFields & PayloadFields & {
  schema: string;
  })[]]>

  Inherited from AbstractWitness.bindQueryInternal

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:42

### `Protected` bindQueryResult

- bindQueryResult<T>(query, payloads, additionalWitnesses?): PromiseEx<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>, AccountInstance[]>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    } | PayloadWrapper<SchemaFields & PayloadFields & QueryFields & {
    schema: string;
    }>

  #### Parameters

  - ##### query: T

  - ##### payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` additionalWitnesses: AccountInstance[]

  #### Returns PromiseEx<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>, AccountInstance[]>

  Inherited from AbstractWitness.bindQueryResult

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:43

### clearListeners

- clearListeners(eventNames): void

- #### Parameters

  - ##### eventNames: keyof WitnessModuleEventData | (keyof WitnessModuleEventData)[]

  #### Returns void

  Inherited from AbstractWitness.clearListeners

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:7

### discover

- discover(): Promisable<(SchemaFields & PayloadFields & {
  schema: string;
  })[], never>

- #### Returns Promisable<(SchemaFields & PayloadFields & {
  schema: string;
  })[], never>

  Inherited from AbstractWitness.discover

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:32

### emit

- emit<TEventName, TEventArgs>(eventName, eventArgs): Promise<void>

- #### Type Parameters

  - #### TEventName extends keyof WitnessModuleEventData = keyof WitnessModuleEventData

  - #### TEventArgs extends EventArgs = WitnessModuleEventData[TEventName]

  #### Parameters

  - ##### eventName: TEventName

  - ##### eventArgs: TEventArgs

  #### Returns Promise<void>

  Inherited from AbstractWitness.emit

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:8

### emitSerial

- emitSerial<TEventName, TEventArgs>(eventName, eventArgs): Promise<void>

- #### Type Parameters

  - #### TEventName extends keyof WitnessModuleEventData = keyof WitnessModuleEventData

  - #### TEventArgs extends EventArgs = WitnessModuleEventData[TEventName]

  #### Parameters

  - ##### eventName: TEventName

  - ##### eventArgs: TEventArgs

  #### Returns Promise<void>

  Inherited from AbstractWitness.emitSerial

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:9

### `Protected` initializeQueryAccounts

- initializeQueryAccounts(): void

- #### Returns void

  Inherited from AbstractWitness.initializeQueryAccounts

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:77

### listenerCount

- listenerCount(eventNames): number

- #### Parameters

  - ##### eventNames: keyof WitnessModuleEventData | (keyof WitnessModuleEventData)[]

  #### Returns number

  Inherited from AbstractWitness.listenerCount

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:10

### `Protected` loadAccount

- loadAccount(account?): AccountInstance

- #### Parameters

  - ##### `Optional` account: AccountInstance

  #### Returns AccountInstance

  Inherited from AbstractWitness.loadAccount

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:78

### moduleAccountQuery

- moduleAccountQuery(): Promisable<(SchemaFields & PayloadFields & {
  address: string;
  name?: string;
  schema: "network.xyo.address";
  } | SchemaFields & PayloadFields & {
  address: string;
  previousHash?: string;
  schema: string;
  })[], never>

- #### Returns Promisable<(SchemaFields & PayloadFields & {
  address: string;
  name?: string;
  schema: "network.xyo.address";
  } | SchemaFields & PayloadFields & {
  address: string;
  previousHash?: string;
  schema: string;
  })[], never>

  Inherited from AbstractWitness.moduleAccountQuery

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:33

### observe

- observe(fields?): Promisable<(SchemaFields & PayloadFields & {
  schema: string;
  })[], never>

- #### Parameters

  - ##### `Optional` fields: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  #### Returns Promisable<(SchemaFields & PayloadFields & {
  schema: string;
  })[], never>

  Overrides AbstractWitness.observe

  - Defined in modules/packages/witness/dist/types/TimestampWitness.d.ts:6

### off

- off<TEventName>(eventNames, listener): void

- #### Type Parameters

  - #### TEventName extends keyof WitnessModuleEventData

  #### Parameters

  - ##### eventNames: TEventName | TEventName[]

  - ##### listener: EventListener<WitnessModuleEventData[TEventName]>

  #### Returns void

  Inherited from AbstractWitness.off

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:11

### offAny

- offAny(listener): void

- #### Parameters

  - ##### listener: EventAnyListener<EventArgs>

  #### Returns void

  Inherited from AbstractWitness.offAny

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:12

### on

- on<TEventName>(eventNames, listener): (() => void)

- #### Type Parameters

  - #### TEventName extends keyof WitnessModuleEventData

  #### Parameters

  - ##### eventNames: TEventName | TEventName[]

  - ##### listener: EventListener<WitnessModuleEventData[TEventName]>

  #### Returns (() => void)

  - - (): void

    - #### Returns void

  Inherited from AbstractWitness.on

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:13

### onAny

- onAny(listener): (() => void)

- #### Parameters

  - ##### listener: EventAnyListener<EventArgs>

  #### Returns (() => void)

  - - (): void

    - #### Returns void

  Inherited from AbstractWitness.onAny

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:14

### once

- once<TEventName>(eventName, listener): (() => void)

- #### Type Parameters

  - #### TEventName extends keyof WitnessModuleEventData

  #### Parameters

  - ##### eventName: TEventName

  - ##### listener: EventListener<WitnessModuleEventData[TEventName]>

  #### Returns (() => void)

  - - (): void

    - #### Returns void

  Inherited from AbstractWitness.once

  - Defined in modules/packages/module/packages/abstract/dist/types/BaseEmitter.d.ts:15

### query

- query<T, TConfig>(query, payloads?, queryConfig?): Promise<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    } = SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }

  - #### TConfig extends SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema"> = SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` queryConfig: TConfig

  #### Returns Promise<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>>

  Inherited from AbstractWitness.query

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:34

### `Protected` queryHandler

- queryHandler<T, TConfig>(query, payloads?, queryConfig?): Promise<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>>

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    } = SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }

  - #### TConfig extends SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema"> = SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` queryConfig: TConfig

  #### Returns Promise<ModuleQueryResult<SchemaFields & PayloadFields & {
  schema: string;
  }>>

  Inherited from AbstractWitness.queryHandler

  - Defined in modules/packages/witness/dist/types/AbstractWitness.d.ts:14

### queryable

- queryable<T, TConfig>(query, payloads?, queryConfig?): boolean

- #### Type Parameters

  - #### T extends SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    } = SchemaFields & PayloadFields & BoundWitnessFields & {
    query: string;
    resultSet?: string;
    schema: "network.xyo.boundwitness";
    }

  - #### TConfig extends SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema"> = SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">

  #### Parameters

  - ##### query: T

  - ##### `Optional` payloads: (SchemaFields & PayloadFields & {
    schema: string;
    })[]

  - ##### `Optional` queryConfig: TConfig

  #### Returns boolean

  Inherited from AbstractWitness.queryable

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:35

### `Protected` resolve

- resolve<TModule>(filter?): Promise<TModule[]>

- #### Type Parameters

  - #### TModule extends ModuleFields<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>> & EventFunctions<ModuleEventData, TModule> = Module<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>, ModuleEventData>

  #### Parameters

  - ##### `Optional` filter: ModuleFilter

  #### Returns Promise<TModule[]>

  Inherited from AbstractWitness.resolve

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:113

### start

- start(_timeout?): Promisable<void, never>

- #### Parameters

  - ##### `Optional` _timeout: number

  #### Returns Promisable<void, never>

  Inherited from AbstractWitness.start

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:36

### started

- started(notStartedAction?): boolean

- #### Parameters

  - ##### `Optional` notStartedAction: "error" | "throw" | "warn" | "log" | "none"

  #### Returns boolean

  Inherited from AbstractWitness.started

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:37

### `Protected` stop

- stop(_timeout?): Promisable<TimestampWitness<P>, never>

- #### Parameters

  - ##### `Optional` _timeout: number

  #### Returns Promisable<TimestampWitness<P>, never>

  Inherited from AbstractWitness.stop

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:114

### subscribe

- subscribe(_queryAccount?): void

- #### Parameters

  - ##### `Optional` _queryAccount: AccountInstance

  #### Returns void

  Inherited from AbstractWitness.subscribe

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:38

### `Protected` validateConfig

- validateConfig(config?, parents?): boolean

- #### Parameters

  - ##### `Optional` config: unknown

  - ##### `Optional` parents: string[]

  #### Returns boolean

  Inherited from AbstractWitness.validateConfig

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:115

### `Static` create

- create<TModule>(this, params?): Promise<TModule>

- #### Type Parameters

  - #### TModule extends ModuleFields<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>> & EventFunctions<ModuleEventData, TModule>

  #### Parameters

  - ##### this: CreatableModule<TModule>

  - ##### `Optional` params: TModule["params"]

  #### Returns Promise<TModule>

  Inherited from AbstractWitness.create

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:30

### `Static` factory

- factory<TModule>(this, params?): CreatableModuleFactory<TModule>

- #### Type Parameters

  - #### TModule extends ModuleFields<ModuleParams<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: string;
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<Omit<SchemaFields & PayloadFields & {
    archivist?: ArchivistModuleConfig;
    name?: string;
    paging?: Record<string, {
    size?: number;
    }>;
    schema: "network.xyo.module.config";
    security?: {
    allowAnonymous?: boolean;
    allowed?: Record<string, (string | CosigningAddressSet)[]>;
    disallowed?: Record<string, string[]>;
    };
    storeQueries?: boolean;
    } & Omit<undefined, "schema">, "schema"> & {
    schema: string;
    }, "schema">, undefined>> & EventFunctions<ModuleEventData, TModule>

  #### Parameters

  - ##### this: CreatableModule<TModule>

  - ##### `Optional` params: TModule["params"]

  #### Returns CreatableModuleFactory<TModule>

  Inherited from AbstractWitness.factory

  - Defined in modules/packages/module/packages/abstract/dist/types/AbstractModule.d.ts:31

Generated using TypeDoc